// ***********************************
// MÉTODOS DE ANÁLISIS DE ESTABILIDAD
// ***********************************
clear
// Se carga la librería de funciones para el diagrama de Bode sintótico.
// L librería debe estar en el directorio de operació. 
pth=pwd()
pth=pth+"\T_d_Control_lib.sci"
exec(pth)

xdel(winsid());
clc

s=%s;
GH=syslin("c",10*(s-10),s*(s+100));
GH

// Método de Routh Hurwitz
routh_t(GH,poly(0,"k"))
kpure(GH)

// Diagramas de Bode
xdel(winsid())
wr=logspace(-2,4,500);
// Singularidades individuales
G1=syslin("c",-1,1);
[M1,F1,w1]=bode_asym(G1,wr,2,"red");
subplot(211)
plot2d("ln",wr,M1,color("red"));
set_my_line_styles(1,2);
xgrid(color("gray"))
title("Diagrama de Bode de Módulo ")
ylabel("Ganancia [dB]")
subplot(212)
plot2d("ln",wr,F1,color("red"));
set_my_line_styles(1,2);
xgrid(color("gray"))
title("Diagrama de Bode de Fase")
ylabel("Fase [º]")
xlabel("Frecuencia [rad/seg]")
figure
G1=syslin("c",1,s);
[M1,F1,w1]=bode_asym(G1,wr,2,"red");
subplot(211)
plot2d("ln",wr,M1,color("blue"));
set_my_line_styles(1,2);
xgrid(color("gray"))
title("Diagrama de Bode de Módulo ")
ylabel("Ganancia [dB]")
subplot(212)
plot2d("ln",wr,F1,color("blue"));
set_my_line_styles(1,2);
xgrid(color("gray"))
title("Diagrama de Bode de Fase")
ylabel("Fase [º]")
xlabel("Frecuencia [rad/seg]")
G1=syslin("c",1,s);
figure
G1=syslin("c",1-s/10,1);
[M1,F1,w1]=bode_asym(G1,wr,2,"red");
subplot(211)
plot2d("ln",wr,M1,color("scilabgreen4"));
set_my_line_styles(1,2);
xgrid(color("gray"))
title("Diagrama de Bode de Módulo ")
ylabel("Ganancia [dB]")
subplot(212)
plot2d("ln",wr,F1,color("scilabgreen4"));
set_my_line_styles(1,2);
xgrid(color("gray"))
title("Diagrama de Bode de Fase")
ylabel("Fase [º]")
xlabel("Frecuencia [rad/seg]")
figure
G1=syslin("c",1,1+s/100);
[M1,F1,w1]=bode_asym(G1,wr,2,"red");
subplot(211)
plot2d("ln",wr,M1,color("magenta"));
set_my_line_styles(1,2);
xgrid(color("gray"))
title("Diagrama de Bode de Módulo ")
ylabel("Ganancia [dB]")
subplot(212)
plot2d("ln",wr,F1,color("magenta"));
set_my_line_styles(1,2);
xgrid(color("gray"))
title("Diagrama de Bode de Fase")
ylabel("Fase [º]")
xlabel("Frecuencia [rad/seg]")

// Bode asintótico
xdel(winsid())
[M1,F1,w1]=bode_asym(GH,wr,2,"red");
g_margin(GH)
F180=-180*ones(1,500);
subplot(211)
plot2d("ln",wr,M1,color("blue"));
set_my_line_styles(1,2);
xgrid(color("gray"))
title("Diagrama de Bode de Módulo ")
ylabel("Ganancia [dB]")
subplot(212)
plot2d("ln",wr,F1,color("blue"));
set_my_line_styles(1,2);
plot(wr,F180,"--r");
plot(wr,2*F180,"--r");
xgrid(color("gray"))
title("Diagrama de Bode de Fase")
ylabel("Fase [º]")
xlabel("Frecuencia [rad/seg]")

// Nyquist Logarítmico

TrayectoNyq(2);
figure("BackgroundColor",[1 1 1]);
LogNyquist(10*GH,6,2);
Mod_inv(0.5)
